package com.jiayue.ssi.job;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jiayue.ssi.entity.SysAlarm;
import com.jiayue.ssi.entity.SysPolicy;
import com.jiayue.ssi.entity.server.Jvm;
import com.jiayue.ssi.service.SysAlarmService;
import com.jiayue.ssi.service.SysPolicyService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

/**
* 检测内存告警
*
* @author xsl
* @since 2023/04/06
*/
@Service
@EnableScheduling
@Slf4j
public class AutoScanMemory {
    @Autowired
    SysPolicyService sysPolicyService;
    @Autowired
    SysAlarmService sysAlarmService;

    /**
     * 每30分钟执行一次扫描
     */
    @Scheduled(cron = "0 0/30 * * * ?")
    public void scanMemory() throws Exception{
        SysPolicy sysPolicy = sysPolicyService.getOne(new QueryWrapper<>());
        int memoryWarn = sysPolicy.getMemoryWarn();
        Jvm jvm = new Jvm();
        jvm.setTotal(Runtime.getRuntime().totalMemory());
        jvm.setMax(Runtime.getRuntime().maxMemory());
        jvm.setFree(Runtime.getRuntime().freeMemory());
        if ((100-jvm.getUsage())<memoryWarn){
            SysAlarm sysAlarm = new SysAlarm();
            sysAlarm.setAlarmContent("内存低于"+memoryWarn+"%");
            sysAlarm.setReadSign("0");
            // 低于策略设定值则告警
            sysAlarmService.save(sysAlarm);
        }
    }
}
